﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr175_1
{
    // Объявление делегата: 
    delegate char MyDelegate(int n);
    
    // Класс: 
    class MyClass {
        // Открытое символьное поле: 
        public char symbol;
        // Поле, являющееся ссылкой на экземпляр делегата: 
        public MyDelegate get;
        // Конструктор, второй аргумент которого ссылка на
        // экземпляр делегата:
        public MyClass(char s, MyDelegate md) {
            // Присваивание значения полю: 
            symbol = s;
            // Использование ссылки на экземпляр делегата: 
            get = md;
        }
        // Метод с аргументом, являющимся ссылкой на экземпляр 
        // делегата:
        public void set(MyDelegate md) {
            // Использование ссылки на экземпляр делегата: 
            get = md;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта. Вторым аргументом является 
            // анонимный метод:
            MyClass obj = new MyClass('K', // Символьный аргумент 
                delegate(int n)
                {          // Анонимный метод
                    return (char)('A' + n);
                }
        );
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ: \'{0}\'", obj.get(3));
            // Вызов метода, аргументом которому передан
            // анонимный метод:
            obj.set(
                delegate(int n)
                {
                    return (char)(obj.symbol + n);
                }
            );
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ: \'{0}\'", obj.get(3));
            // Задержка:
            Console.ReadLine();
        }
    }
}
